import{s as xe,n as ye,o as Se}from"../chunks/scheduler.22bf70d2.js";import{S as ze,i as Ce,g as a,s as n,r as b,A as Pe,h as s,f as t,c as l,j as f,u as $,x as L,k as v,y as o,a as i,v as D,d as w,t as x,w as y}from"../chunks/index.59178e06.js";import{D as I}from"../chunks/Docstring.cefe8221.js";import{H as Ee}from"../chunks/Heading.f8746c79.js";function Ne(he){let c,B,M,F,S,G,p,z,oe,W,fe="This plugin is used to integrate DeepSpeed.",ie,_,C,pe,T,ve="Process the DeepSpeed config with the values from the kwargs.",J,m,P,ce,V,_e=`Dummy optimizer presents model parameters or param groups, this is primarily used to follow conventional training
loop when optimizer config is specified in the deepspeed config file.`,K,d,E,me,A,be=`Dummy scheduler presents model parameters or param groups, this is primarily used to follow conventional training
loop when scheduler config is specified in the deepspeed config file.`,Q,u,N,de,q,$e="Internal wrapper for deepspeed.runtime.engine.DeepSpeedEngine. This is used to follow conventional training loop.",X,g,O,ue,R,De="Internal wrapper around a deepspeed optimizer.",Y,h,k,ge,U,we="Internal wrapper around a deepspeed scheduler.",Z,j,ee;return S=new Ee({props:{title:"Utilities for DeepSpeed",local:"accelerate.DeepSpeedPlugin",headingTag:"h1"}}),z=new I({props:{name:"class accelerate.DeepSpeedPlugin",anchor:"accelerate.DeepSpeedPlugin",parameters:[{name:"hf_ds_config",val:": Any = None"},{name:"gradient_accumulation_steps",val:": int = None"},{name:"gradient_clipping",val:": float = None"},{name:"zero_stage",val:": int = None"},{name:"is_train_batch_min",val:": str = True"},{name:"offload_optimizer_device",val:": bool = None"},{name:"offload_param_device",val:": bool = None"},{name:"offload_optimizer_nvme_path",val:": str = None"},{name:"offload_param_nvme_path",val:": str = None"},{name:"zero3_init_flag",val:": bool = None"},{name:"zero3_save_16bit_model",val:": bool = None"}],source:"https://github.com/huggingface/accelerate/blob/v0.29.0/src/accelerate/utils/dataclasses.py#L662"}}),C=new I({props:{name:"deepspeed_config_process",anchor:"accelerate.DeepSpeedPlugin.deepspeed_config_process",parameters:[{name:"prefix",val:" = ''"},{name:"mismatches",val:" = None"},{name:"config",val:" = None"},{name:"must_match",val:" = True"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.29.0/src/accelerate/utils/dataclasses.py#L856"}}),P=new I({props:{name:"class accelerate.utils.DummyOptim",anchor:"accelerate.utils.DummyOptim",parameters:[{name:"params",val:""},{name:"lr",val:" = 0.001"},{name:"weight_decay",val:" = 0"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"accelerate.utils.DummyOptim.lr",description:`<strong>lr</strong> (float) &#x2014;
Learning rate.`,name:"lr"},{anchor:"accelerate.utils.DummyOptim.params",description:`<strong>params</strong> (iterable) &#x2014; iterable of parameters to optimize or dicts defining
parameter groups`,name:"params"},{anchor:"accelerate.utils.DummyOptim.weight_decay",description:`<strong>weight_decay</strong> (float) &#x2014;
Weight decay.`,name:"weight_decay"},{anchor:"accelerate.utils.DummyOptim.*kwargs",description:`*<strong>*kwargs</strong> (additional keyword arguments, <em>optional</em>) &#x2014;
Other arguments.`,name:"*kwargs"}],source:"https://github.com/huggingface/accelerate/blob/v0.29.0/src/accelerate/utils/deepspeed.py#L225"}}),E=new I({props:{name:"class accelerate.utils.DummyScheduler",anchor:"accelerate.utils.DummyScheduler",parameters:[{name:"optimizer",val:""},{name:"total_num_steps",val:" = None"},{name:"warmup_num_steps",val:" = 0"},{name:"lr_scheduler_callable",val:" = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"accelerate.utils.DummyScheduler.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.optimizer.Optimizer</code>) &#x2014;
The optimizer to wrap.`,name:"optimizer"},{anchor:"accelerate.utils.DummyScheduler.total_num_steps",description:`<strong>total_num_steps</strong> (int, <em>optional</em>) &#x2014;
Total number of steps.`,name:"total_num_steps"},{anchor:"accelerate.utils.DummyScheduler.warmup_num_steps",description:`<strong>warmup_num_steps</strong> (int, <em>optional</em>) &#x2014;
Number of steps for warmup.`,name:"warmup_num_steps"},{anchor:"accelerate.utils.DummyScheduler.lr_scheduler_callable",description:`<strong>lr_scheduler_callable</strong> (callable, <em>optional</em>) &#x2014;
A callable function that creates an LR Scheduler. It accepts only one argument <code>optimizer</code>.`,name:"lr_scheduler_callable"},{anchor:"accelerate.utils.DummyScheduler.*kwargs",description:`*<strong>*kwargs</strong> (additional keyword arguments, <em>optional</em>) &#x2014;
Other arguments.`,name:"*kwargs"}],source:"https://github.com/huggingface/accelerate/blob/v0.29.0/src/accelerate/utils/deepspeed.py#L248"}}),N=new I({props:{name:"class accelerate.utils.DeepSpeedEngineWrapper",anchor:"accelerate.utils.DeepSpeedEngineWrapper",parameters:[{name:"engine",val:""}],parametersDescription:[{anchor:"accelerate.utils.DeepSpeedEngineWrapper.engine",description:"<strong>engine</strong> (deepspeed.runtime.engine.DeepSpeedEngine) &#x2014; deepspeed engine to wrap",name:"engine"}],source:"https://github.com/huggingface/accelerate/blob/v0.29.0/src/accelerate/utils/deepspeed.py#L153"}}),O=new I({props:{name:"class accelerate.utils.DeepSpeedOptimizerWrapper",anchor:"accelerate.utils.DeepSpeedOptimizerWrapper",parameters:[{name:"optimizer",val:""}],parametersDescription:[{anchor:"accelerate.utils.DeepSpeedOptimizerWrapper.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.optimizer.Optimizer</code>) &#x2014;
The optimizer to wrap.`,name:"optimizer"}],source:"https://github.com/huggingface/accelerate/blob/v0.29.0/src/accelerate/utils/deepspeed.py#L181"}}),k=new I({props:{name:"class accelerate.utils.DeepSpeedSchedulerWrapper",anchor:"accelerate.utils.DeepSpeedSchedulerWrapper",parameters:[{name:"scheduler",val:""},{name:"optimizers",val:""}],parametersDescription:[{anchor:"accelerate.utils.DeepSpeedSchedulerWrapper.scheduler",description:`<strong>scheduler</strong> (<code>torch.optim.lr_scheduler.LambdaLR</code>) &#x2014;
The scheduler to wrap.`,name:"scheduler"},{anchor:"accelerate.utils.DeepSpeedSchedulerWrapper.optimizers",description:"<strong>optimizers</strong> (one or a list of <code>torch.optim.Optimizer</code>) &#x2014;",name:"optimizers"}],source:"https://github.com/huggingface/accelerate/blob/v0.29.0/src/accelerate/utils/deepspeed.py#L208"}}),{c(){c=a("meta"),B=n(),M=a("p"),F=n(),b(S.$$.fragment),G=n(),p=a("div"),b(z.$$.fragment),oe=n(),W=a("p"),W.textContent=fe,ie=n(),_=a("div"),b(C.$$.fragment),pe=n(),T=a("p"),T.textContent=ve,J=n(),m=a("div"),b(P.$$.fragment),ce=n(),V=a("p"),V.textContent=_e,K=n(),d=a("div"),b(E.$$.fragment),me=n(),A=a("p"),A.textContent=be,Q=n(),u=a("div"),b(N.$$.fragment),de=n(),q=a("p"),q.textContent=$e,X=n(),g=a("div"),b(O.$$.fragment),ue=n(),R=a("p"),R.textContent=De,Y=n(),h=a("div"),b(k.$$.fragment),ge=n(),U=a("p"),U.textContent=we,Z=n(),j=a("p"),this.h()},l(e){const r=Pe("svelte-u9bgzb",document.head);c=s(r,"META",{name:!0,content:!0}),r.forEach(t),B=l(e),M=s(e,"P",{}),f(M).forEach(t),F=l(e),$(S.$$.fragment,e),G=l(e),p=s(e,"DIV",{class:!0});var H=f(p);$(z.$$.fragment,H),oe=l(H),W=s(H,"P",{"data-svelte-h":!0}),L(W)!=="svelte-i90brl"&&(W.textContent=fe),ie=l(H),_=s(H,"DIV",{class:!0});var te=f(_);$(C.$$.fragment,te),pe=l(te),T=s(te,"P",{"data-svelte-h":!0}),L(T)!=="svelte-ht2n4g"&&(T.textContent=ve),te.forEach(t),H.forEach(t),J=l(e),m=s(e,"DIV",{class:!0});var re=f(m);$(P.$$.fragment,re),ce=l(re),V=s(re,"P",{"data-svelte-h":!0}),L(V)!=="svelte-gs0woa"&&(V.textContent=_e),re.forEach(t),K=l(e),d=s(e,"DIV",{class:!0});var ae=f(d);$(E.$$.fragment,ae),me=l(ae),A=s(ae,"P",{"data-svelte-h":!0}),L(A)!=="svelte-mxz6g6"&&(A.textContent=be),ae.forEach(t),Q=l(e),u=s(e,"DIV",{class:!0});var ne=f(u);$(N.$$.fragment,ne),de=l(ne),q=s(ne,"P",{"data-svelte-h":!0}),L(q)!=="svelte-nq2ve"&&(q.textContent=$e),ne.forEach(t),X=l(e),g=s(e,"DIV",{class:!0});var se=f(g);$(O.$$.fragment,se),ue=l(se),R=s(se,"P",{"data-svelte-h":!0}),L(R)!=="svelte-1r36mso"&&(R.textContent=De),se.forEach(t),Y=l(e),h=s(e,"DIV",{class:!0});var le=f(h);$(k.$$.fragment,le),ge=l(le),U=s(le,"P",{"data-svelte-h":!0}),L(U)!=="svelte-rm0vqe"&&(U.textContent=we),le.forEach(t),Z=l(e),j=s(e,"P",{}),f(j).forEach(t),this.h()},h(){v(c,"name","hf:doc:metadata"),v(c,"content",Oe),v(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(p,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(m,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(d,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),v(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,r){o(document.head,c),i(e,B,r),i(e,M,r),i(e,F,r),D(S,e,r),i(e,G,r),i(e,p,r),D(z,p,null),o(p,oe),o(p,W),o(p,ie),o(p,_),D(C,_,null),o(_,pe),o(_,T),i(e,J,r),i(e,m,r),D(P,m,null),o(m,ce),o(m,V),i(e,K,r),i(e,d,r),D(E,d,null),o(d,me),o(d,A),i(e,Q,r),i(e,u,r),D(N,u,null),o(u,de),o(u,q),i(e,X,r),i(e,g,r),D(O,g,null),o(g,ue),o(g,R),i(e,Y,r),i(e,h,r),D(k,h,null),o(h,ge),o(h,U),i(e,Z,r),i(e,j,r),ee=!0},p:ye,i(e){ee||(w(S.$$.fragment,e),w(z.$$.fragment,e),w(C.$$.fragment,e),w(P.$$.fragment,e),w(E.$$.fragment,e),w(N.$$.fragment,e),w(O.$$.fragment,e),w(k.$$.fragment,e),ee=!0)},o(e){x(S.$$.fragment,e),x(z.$$.fragment,e),x(C.$$.fragment,e),x(P.$$.fragment,e),x(E.$$.fragment,e),x(N.$$.fragment,e),x(O.$$.fragment,e),x(k.$$.fragment,e),ee=!1},d(e){e&&(t(B),t(M),t(F),t(G),t(p),t(J),t(m),t(K),t(d),t(Q),t(u),t(X),t(g),t(Y),t(h),t(Z),t(j)),t(c),y(S,e),y(z),y(C),y(P),y(E),y(N),y(O),y(k)}}}const Oe='{"title":"Utilities for DeepSpeed","local":"accelerate.DeepSpeedPlugin","sections":[],"depth":1}';function ke(he){return Se(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ve extends ze{constructor(c){super(),Ce(this,c,ke,Ne,xe,{})}}export{Ve as component};
